searchData={"content_type":"text/markdown","items":[{"doc":"This module parse and validate arguments.","ref":"DoIt.Argument.html","title":"DoIt.Argument","type":"module"},{"doc":"","ref":"DoIt.Argument.html#parse_input/2","title":"DoIt.Argument.parse_input/2","type":"function"},{"doc":"","ref":"DoIt.Argument.html#validate_definition/1","title":"DoIt.Argument.validate_definition/1","type":"function"},{"doc":"","ref":"DoIt.Argument.html#validate_definition_allowed_values/1","title":"DoIt.Argument.validate_definition_allowed_values/1","type":"function"},{"doc":"","ref":"DoIt.Argument.html#validate_definition_description/1","title":"DoIt.Argument.validate_definition_description/1","type":"function"},{"doc":"","ref":"DoIt.Argument.html#validate_definition_name/1","title":"DoIt.Argument.validate_definition_name/1","type":"function"},{"doc":"","ref":"DoIt.Argument.html#validate_definition_type/1","title":"DoIt.Argument.validate_definition_type/1","type":"function"},{"doc":"","ref":"DoIt.Argument.html#validate_input/2","title":"DoIt.Argument.validate_input/2","type":"function"},{"doc":"","ref":"DoIt.Argument.html#validate_input_allowed_values/1","title":"DoIt.Argument.validate_input_allowed_values/1","type":"function"},{"doc":"","ref":"DoIt.Argument.html#validate_input_allowed_values/2","title":"DoIt.Argument.validate_input_allowed_values/2","type":"function"},{"doc":"","ref":"DoIt.Argument.html#validate_input_value/1","title":"DoIt.Argument.validate_input_value/1","type":"function"},{"doc":"","ref":"DoIt.Argument.html#validate_input_value/2","title":"DoIt.Argument.validate_input_value/2","type":"function"},{"doc":"","ref":"DoIt.Argument.html#t:t/0","title":"DoIt.Argument.t/0","type":"type"},{"doc":"Provides shell auto-completion functionality for DoIt CLI applications.\n\nThis module generates completion scripts for popular shells (bash, fish, zsh)\nand provides the completion logic for commands, subcommands, options, and arguments.","ref":"DoIt.Completion.html","title":"DoIt.Completion","type":"module"},{"doc":"Completes values for command arguments.","ref":"DoIt.Completion.html#complete_argument_value/3","title":"DoIt.Completion.complete_argument_value/3","type":"function"},{"doc":"Provides completions for the given command line arguments.\n\nThis is the main entry point called by shell completion scripts.","ref":"DoIt.Completion.html#complete_command/2","title":"DoIt.Completion.complete_command/2","type":"function"},{"doc":"Completes values for a specific option.","ref":"DoIt.Completion.html#complete_option_value/3","title":"DoIt.Completion.complete_option_value/3","type":"function"},{"doc":"Lists all available completions for debugging purposes.","ref":"DoIt.Completion.html#debug_completions/1","title":"DoIt.Completion.debug_completions/1","type":"function"},{"doc":"Generates a bash completion script for the given main module and app name.","ref":"DoIt.Completion.html#generate_bash_completion/2","title":"DoIt.Completion.generate_bash_completion/2","type":"function"},{"doc":"Generates a fish completion script for the given main module and app name.","ref":"DoIt.Completion.html#generate_fish_completion/2","title":"DoIt.Completion.generate_fish_completion/2","type":"function"},{"doc":"Generates a zsh completion script for the given main module and app name.","ref":"DoIt.Completion.html#generate_zsh_completion/2","title":"DoIt.Completion.generate_zsh_completion/2","type":"function"},{"doc":"Gets installation instructions for shell completion.","ref":"DoIt.Completion.html#get_installation_instructions/2","title":"DoIt.Completion.get_installation_instructions/2","type":"function"},{"doc":"Parses the completion context from command line arguments.\n\nReturns one of:\n- `{:command, command_path}` - completing a command or subcommand\n- `{:partial_command, partial, command_path}` - completing a partial command\n- `{:option_value, option_name, command_path}` - completing an option value\n- `{:argument, arg_index, command_path}` - completing an argument\n- `{:partial_option, partial, command_path}` - completing a partial option","ref":"DoIt.Completion.html#parse_completion_context/2","title":"DoIt.Completion.parse_completion_context/2","type":"function"},{"doc":"DoIt helper functions.","ref":"DoIt.Helper.html","title":"DoIt.Helper","type":"module"},{"doc":"Validates if all allowed values are of the same type.","ref":"DoIt.Helper.html#validate_list_type/2","title":"DoIt.Helper.validate_list_type/2","type":"function"},{"doc":"iex> DoIt.Helper.validate_list_type([0, 1, 2, 3], :integer)\n    true\n\n    iex> DoIt.Helper.validate_list_type([0, 1, 2.1, 3], :integer)\n    false\n\n    iex> DoIt.Helper.validate_list_type([0.1, 1.1, 2.1, 3.1], :float)\n    true\n\n    iex> DoIt.Helper.validate_list_type([0.1, 1.1, 2, 3.1], :float)\n    false\n\n    iex> DoIt.Helper.validate_list_type([\"warn\", \"error\", \"info\", \"debug\"], :string)\n    true\n\n    iex> DoIt.Helper.validate_list_type([\"warn\", \"error\", \"info\", 0], :string)\n    false\n\n    iex> DoIt.Helper.validate_list_type([\"warn\", \"error\", \"info\", \"debug\"], :unknown)\n    false","ref":"DoIt.Helper.html#validate_list_type/2-examples","title":"Examples - DoIt.Helper.validate_list_type/2","type":"function"},{"doc":"Provides introspection capabilities for DoIt commands and their structure.\n\nThis module enables analysis of command hierarchies, options, arguments,\nand other metadata needed for features like auto-completion.","ref":"DoIt.Introspection.html","title":"DoIt.Introspection","type":"module"},{"doc":"Finds a command module by name from a MainCommand module.\n\nReturns the module atom or nil if not found.","ref":"DoIt.Introspection.html#find_command_module/2","title":"DoIt.Introspection.find_command_module/2","type":"function"},{"doc":"Finds a subcommand module by name from a Command module.\n\nReturns the module atom or nil if not found.","ref":"DoIt.Introspection.html#find_subcommand_module/2","title":"DoIt.Introspection.find_subcommand_module/2","type":"function"},{"doc":"Gets all possible command paths as flat list.\n\nReturns a list of command paths where each path is a list of strings.","ref":"DoIt.Introspection.html#get_all_command_paths/1","title":"DoIt.Introspection.get_all_command_paths/1","type":"function"},{"doc":"Gets all top-level commands from a MainCommand module.\n\nReturns a list of command names as strings.","ref":"DoIt.Introspection.html#get_all_commands/1","title":"DoIt.Introspection.get_all_commands/1","type":"function"},{"doc":"Gets all arguments from a Command module.\n\nReturns a list of DoIt.Argument structs.","ref":"DoIt.Introspection.html#get_command_arguments/1","title":"DoIt.Introspection.get_command_arguments/1","type":"function"},{"doc":"Gets all option flags (--name and -alias) from a Command module.\n\nReturns a list of option flags as strings.","ref":"DoIt.Introspection.html#get_command_option_flags/1","title":"DoIt.Introspection.get_command_option_flags/1","type":"function"},{"doc":"Gets all options from a Command module.\n\nReturns a list of DoIt.Option structs.","ref":"DoIt.Introspection.html#get_command_options/1","title":"DoIt.Introspection.get_command_options/1","type":"function"},{"doc":"Gets the command structure as a nested map for introspection.\n\nReturns a map containing the full command hierarchy with metadata.","ref":"DoIt.Introspection.html#get_command_structure/1","title":"DoIt.Introspection.get_command_structure/1","type":"function"},{"doc":"Gets all subcommands from a Command module.\n\nReturns a list of subcommand names as strings.","ref":"DoIt.Introspection.html#get_subcommands/1","title":"DoIt.Introspection.get_subcommands/1","type":"function"},{"doc":"Checks if a command has subcommands.","ref":"DoIt.Introspection.html#has_subcommands?/1","title":"DoIt.Introspection.has_subcommands?/1","type":"function"},{"doc":"Resolves a command path to its final command module.\n\nTakes a main module and a list of command/subcommand names,\nreturns the final command module or nil if path is invalid.","ref":"DoIt.Introspection.html#resolve_command_path/2","title":"DoIt.Introspection.resolve_command_path/2","type":"function"},{"doc":"iex> resolve_command_path(MyApp, [\"user\", \"create\"])\n    MyApp.User.Create\n    \n    iex> resolve_command_path(MyApp, [\"invalid\"])\n    nil","ref":"DoIt.Introspection.html#resolve_command_path/2-examples","title":"Examples - DoIt.Introspection.resolve_command_path/2","type":"function"},{"doc":"This module parse and validate options.","ref":"DoIt.Option.html","title":"DoIt.Option","type":"module"},{"doc":"","ref":"DoIt.Option.html#default/2","title":"DoIt.Option.default/2","type":"function"},{"doc":"","ref":"DoIt.Option.html#default_filter/1","title":"DoIt.Option.default_filter/1","type":"function"},{"doc":"","ref":"DoIt.Option.html#default_map/2","title":"DoIt.Option.default_map/2","type":"function"},{"doc":"","ref":"DoIt.Option.html#group/1","title":"DoIt.Option.group/1","type":"function"},{"doc":"","ref":"DoIt.Option.html#parse_input/2","title":"DoIt.Option.parse_input/2","type":"function"},{"doc":"","ref":"DoIt.Option.html#validate_definition/1","title":"DoIt.Option.validate_definition/1","type":"function"},{"doc":"","ref":"DoIt.Option.html#validate_definition_alias/1","title":"DoIt.Option.validate_definition_alias/1","type":"function"},{"doc":"","ref":"DoIt.Option.html#validate_definition_allowed_values/1","title":"DoIt.Option.validate_definition_allowed_values/1","type":"function"},{"doc":"","ref":"DoIt.Option.html#validate_definition_default/1","title":"DoIt.Option.validate_definition_default/1","type":"function"},{"doc":"","ref":"DoIt.Option.html#validate_definition_description/1","title":"DoIt.Option.validate_definition_description/1","type":"function"},{"doc":"","ref":"DoIt.Option.html#validate_definition_keep/1","title":"DoIt.Option.validate_definition_keep/1","type":"function"},{"doc":"","ref":"DoIt.Option.html#validate_definition_name/1","title":"DoIt.Option.validate_definition_name/1","type":"function"},{"doc":"","ref":"DoIt.Option.html#validate_definition_type/1","title":"DoIt.Option.validate_definition_type/1","type":"function"},{"doc":"","ref":"DoIt.Option.html#validate_input/2","title":"DoIt.Option.validate_input/2","type":"function"},{"doc":"","ref":"DoIt.Option.html#validate_input_allowed_values/1","title":"DoIt.Option.validate_input_allowed_values/1","type":"function"},{"doc":"","ref":"DoIt.Option.html#validate_input_allowed_values/2","title":"DoIt.Option.validate_input_allowed_values/2","type":"function"},{"doc":"","ref":"DoIt.Option.html#validate_input_value/1","title":"DoIt.Option.validate_input_value/1","type":"function"},{"doc":"","ref":"DoIt.Option.html#validate_input_value/2","title":"DoIt.Option.validate_input_value/2","type":"function"},{"doc":"","ref":"DoIt.Option.html#t:t/0","title":"DoIt.Option.t/0","type":"type"},{"doc":"This module formats command help outputs.","ref":"DoIt.Output.html","title":"DoIt.Output","type":"module"},{"doc":"It returns the allowed values from the given `DoIt.Argument`.","ref":"DoIt.Output.html#format_argument_allowed_values/1","title":"DoIt.Output.format_argument_allowed_values/1","type":"function"},{"doc":"iex> DoIt.Output.format_argument_allowed_values(%DoIt.Argument{name: :op, type: :string, description: \"Operation\", allowed_values: [\"+\", \"-\", \"*\", \"/\"]})\n    \" (Allowed Values: \\\"+\\\", \\\"-\\\", \\\"*\\\", \\\"/\\\")\"\n\n    iex> DoIt.Output.format_argument_allowed_values(%DoIt.Argument{name: :verbose, type: :boolean, description: \"Makes the command verbose\"})\n    \"\"\n\n    iex> DoIt.Output.format_argument_allowed_values(%DoIt.Argument{name: :number, type: :integer, description: \"Numerical digit\", allowed_values: [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]})\n    \" (Allowed Values: 0, 1, 2, 3, 4, 5, 6, 7, 8, 9)\"","ref":"DoIt.Output.html#format_argument_allowed_values/1-examples","title":"Examples - DoIt.Output.format_argument_allowed_values/1","type":"function"},{"doc":"It returns the description from `DoIt.Argument`.","ref":"DoIt.Output.html#format_argument_description/1","title":"DoIt.Output.format_argument_description/1","type":"function"},{"doc":"iex> DoIt.Output.format_argument_description(%DoIt.Argument{name: :verbose, type: :boolean, description: \"Makes the command verbose\"})\n    \"Makes the command verbose\"","ref":"DoIt.Output.html#format_argument_description/1-example","title":"Example - DoIt.Output.format_argument_description/1","type":"function"},{"doc":"It formats the given `DoIt.Argument` name attribute with spaces on the right, accordingly with the `align` parameter.","ref":"DoIt.Output.html#format_argument_name/2","title":"DoIt.Output.format_argument_name/2","type":"function"},{"doc":"iex> DoIt.Output.format_argument_name(%DoIt.Argument{name: :verbose, type: :boolean, description: \"Makes the command verbose\"}, 15)\n    \"verbose        \"","ref":"DoIt.Output.html#format_argument_name/2-examples","title":"Examples - DoIt.Output.format_argument_name/2","type":"function"},{"doc":"It formats the given `DoIt.Option` alias attribute.","ref":"DoIt.Output.html#format_option_alias/1","title":"DoIt.Output.format_option_alias/1","type":"function"},{"doc":"iex> DoIt.Output.format_option_alias(%DoIt.Option{name: :help, type: :boolean, description: \"Shows the help command\", alias: nil})\n    \"   \"\n\n    iex> DoIt.Output.format_option_alias(%DoIt.Option{name: :help, type: :boolean, description: \"Shows the help command\", alias: :h})\n    \"-h,\"","ref":"DoIt.Output.html#format_option_alias/1-examples","title":"Examples - DoIt.Output.format_option_alias/1","type":"function"},{"doc":"It returns the allowed values from the given `DoIt.Option`.","ref":"DoIt.Output.html#format_option_allowed_values/1","title":"DoIt.Output.format_option_allowed_values/1","type":"function"},{"doc":"iex> DoIt.Output.format_option_allowed_values(%DoIt.Option{name: :op, type: :string, description: \"Operation\", allowed_values: [\"+\", \"-\", \"*\", \"/\"]})\n    \" (Allowed Values: \\\"+\\\", \\\"-\\\", \\\"*\\\", \\\"/\\\")\"\n\n    iex> DoIt.Output.format_option_allowed_values(%DoIt.Option{name: :verbose, type: :boolean, description: \"Makes the command verbose\"})\n    \"\"\n\n    iex> DoIt.Output.format_option_allowed_values(%DoIt.Option{name: :number, type: :integer, description: \"Numerical digit\", allowed_values: [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]})\n    \" (Allowed Values: 0, 1, 2, 3, 4, 5, 6, 7, 8, 9)\"","ref":"DoIt.Output.html#format_option_allowed_values/1-examples","title":"Examples - DoIt.Output.format_option_allowed_values/1","type":"function"},{"doc":"It formats the given `DoIt.Option` default attribute.","ref":"DoIt.Output.html#format_option_default/1","title":"DoIt.Output.format_option_default/1","type":"function"},{"doc":"iex> DoIt.Output.format_option_default(%DoIt.Option{name: :log_level, type: :string, description: \"Set the logging level\", alias: nil, default: \"warn\"})\n    \" (Default: \\\"warn\\\")\"\n\n    iex> DoIt.Output.format_option_default(%DoIt.Option{name: :skip_lines, type: :integer, description: \"Lines to skip\", alias: nil, default: 10})\n    \" (Default: 10)\"\n\n    iex> DoIt.Output.format_option_default(%DoIt.Option{name: :help, type: :boolean, description: \"Shows the help command\", alias: nil})\n    \"\"","ref":"DoIt.Output.html#format_option_default/1-examples","title":"Examples - DoIt.Output.format_option_default/1","type":"function"},{"doc":"It returns the description from `DoIt.Option`.","ref":"DoIt.Output.html#format_option_description/1","title":"DoIt.Output.format_option_description/1","type":"function"},{"doc":"iex> DoIt.Output.format_option_description(%DoIt.Option{name: :help, type: :boolean, description: \"Shows the help command\", alias: nil})\n    \"Shows the help command\"","ref":"DoIt.Output.html#format_option_description/1-examples","title":"Examples - DoIt.Output.format_option_description/1","type":"function"},{"doc":"It formats the given `DoIt.Option` name attribute with spaces on the right, accordingly with the `align` parameter.","ref":"DoIt.Output.html#format_option_name/2","title":"DoIt.Output.format_option_name/2","type":"function"},{"doc":"iex> DoIt.Output.format_option_name(%DoIt.Option{name: :help, type: :boolean, description: \"Shows the help command\", alias: nil}, 10)\n    \"--help      \"\n\n    iex> DoIt.Output.format_option_name(%DoIt.Option{name: :log_level, type: :string, description: \"Set the logging level\", alias: nil}, 12)\n    \"--log-level   \"","ref":"DoIt.Output.html#format_option_name/2-examples","title":"Examples - DoIt.Output.format_option_name/2","type":"function"},{"doc":"It gets the length of the longer name attribute.","ref":"DoIt.Output.html#longer_name/1","title":"DoIt.Output.longer_name/1","type":"function"},{"doc":"iex> DoIt.Output.longer_name([%{name: \"great\"}, %{name: \"greatest\"}])\n    8\n\n    iex> DoIt.Output.longer_name([%{name: \"Elixir\"}, %{name: \"Erlang\"}, %{name: \"DoIt\"}, %{name: \"OTP\"}])\n    6","ref":"DoIt.Output.html#longer_name/1-examples","title":"Examples - DoIt.Output.longer_name/1","type":"function"},{"doc":"","ref":"DoIt.Output.html#print_errors/1","title":"DoIt.Output.print_errors/1","type":"function"},{"doc":"","ref":"DoIt.Output.html#print_help/1","title":"DoIt.Output.print_help/1","type":"function"},{"doc":"","ref":"DoIt.Output.html#print_invalid_options/2","title":"DoIt.Output.print_invalid_options/2","type":"function"},{"doc":"Initializes DoIt persistent configuration.","ref":"Mix.Tasks.DoIt.Config.Init.html","title":"mix do_it.config.init","type":"task"},{"doc":"$ mix do_it.config.init","ref":"Mix.Tasks.DoIt.Config.Init.html#module-examples","title":"Examples - mix do_it.config.init","type":"task"},{"doc":"Generates shell completion scripts for your DoIt CLI application.\n\nThis task helps you generate completion scripts for popular shells and optionally\nsave them to appropriate locations.","ref":"Mix.Tasks.DoIt.Gen.Completion.html","title":"mix do_it.gen.completion","type":"task"},{"doc":"mix do_it.gen.completion [options]","ref":"Mix.Tasks.DoIt.Gen.Completion.html#module-usage","title":"Usage - mix do_it.gen.completion","type":"task"},{"doc":"* `--shell` (`-s`) - Shell to generate completion for (bash, fish, zsh)\n  * `--output` (`-o`) - Output file path (defaults to stdout)\n  * `--install` (`-i`) - Show installation instructions instead of generating script\n  * `--main-module` (`-m`) - Main module to use (auto-detected if not specified)\n  * `--app-name` (`-a`) - Application name (defaults to app name from mix.exs)","ref":"Mix.Tasks.DoIt.Gen.Completion.html#module-options","title":"Options - mix do_it.gen.completion","type":"task"},{"doc":"# Generate bash completion script to stdout\n    mix do_it.gen.completion --shell bash\n\n    # Generate fish completion and save to file\n    mix do_it.gen.completion --shell fish --output ~/.config/fish/completions/myapp.fish\n\n    # Show installation instructions for zsh\n    mix do_it.gen.completion --shell zsh --install\n\n    # Generate for specific main module\n    mix do_it.gen.completion --shell bash --main-module MyApp.CLI","ref":"Mix.Tasks.DoIt.Gen.Completion.html#module-examples","title":"Examples - mix do_it.gen.completion","type":"task"},{"doc":"","ref":"Mix.Tasks.DoIt.Gen.Completion.html#run/1","title":"Mix.Tasks.DoIt.Gen.Completion.run/1","type":"function"},{"doc":"It shows a problem with an argument definition.","ref":"DoIt.ArgumentDefinitionError.html","title":"DoIt.ArgumentDefinitionError","type":"exception"},{"doc":"It shows a problem with a command definition.","ref":"DoIt.CommandDefinitionError.html","title":"DoIt.CommandDefinitionError","type":"exception"},{"doc":"It shows a problem with the initialization of the persistent configuration.","ref":"DoIt.InitConfigError.html","title":"DoIt.InitConfigError","type":"exception"},{"doc":"It shows a problem with the main command definition.","ref":"DoIt.MainCommandDefinitionError.html","title":"DoIt.MainCommandDefinitionError","type":"exception"},{"doc":"It shows a problem with an option definition.","ref":"DoIt.OptionDefinitionError.html","title":"DoIt.OptionDefinitionError","type":"exception"},{"doc":"[![Build Status](https://github.com/rzcastilho/do_it/workflows/CI/badge.svg)](https://github.com/rzcastilho/do_it/actions) [![Hex.pm](https://img.shields.io/hexpm/v/do_it.svg)](https://hex.pm/packages/do_it) [![Coverage Status](https://coveralls.io/repos/github/rzcastilho/do_it/badge.svg)](https://coveralls.io/github/rzcastilho/do_it) [![Documentation](https://img.shields.io/badge/documentation-gray)](https://hexdocs.pm/do_it/)\n\n# Do It\n\nElixir Command Line Interface Library.\n\nA library that helps to develop CLI tools with Elixir.","ref":"readme.html","title":"README","type":"extras"},{"doc":"The package can be installed by adding `do_it` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:do_it, \"~> 0.7\"}\n  ]\nend\n```","ref":"readme.html#installation","title":"Installation - README","type":"extras"},{"doc":"**_Do It_** have two main components:\n\n  * `DoIt.Command` - represents a single command.\n  * `DoIt.MainCommand` - the entrypoint of the application where you declare all the commands, must be used as `main_module` in `escript` definition.\n\nThe commands `version` and `help` are automatic generated for the client.\n\nThe version number is obtained from `mix.exs` or option `version` in `MainCommand`.\n\nSo, if you have a client named `cli`, you can type `cli version` and `cli help` to get the version number and the list of commands respectively from the client.\n\n#","ref":"readme.html#usage","title":"Usage - README","type":"extras"},{"doc":"It's the entrypoint of your CLI, it generates functions matching all declared commands in that module, delegating the call to the matched command.\n\nA `MainCommand` could be defined as follows:\n\n```elixir\ndefmodule HelloWorld do\n  use DoIt.MainCommand,\n    description: \"HelloWorld CLI\"\n\n  command(HelloWorld.Say)\n  command(HelloWorld.Template)\nend\n```\n\n#","ref":"readme.html#maincommand","title":"MainCommand - README","type":"extras"},{"doc":"We can define a new command as follows:\n\n```elixir\ndefmodule HelloWorld.Say do\n  use DoIt.Command,\n    description: \"Say something!!!\"\n\n  argument(:message, :string, \"Hello message\")\n\n  option(:template, :string, \"Message template\", alias: :t)\n\n  def run(%{message: message}, %{template: template}, _) do\n    hello(message, template)\n  end\n\n  def run(%{message: message}, _, %{config: %{\"default_template\" => template}}) do\n    hello(message, template)\n  end\n\n  def run(_, _, context) do\n    IO.puts(\"Pass a template s parameter or define a default template using template set command\")\n    help(context)\n  end\n\n  defp hello(message, template) do\n    IO.puts(EEx.eval_string(template, assigns: [message: message]))\n  end\nend\n\n```\n\nA `help` option is automatically added to the command to describe its usage.\n\n```shell\n$ ./hello_world say --help\n\nUsage: hello_world say [OPTIONS]  \n\nSay something!!!\n\nArguments:\n  message   Hello message\n\nOptions:\n      --help       Print this help\n  -t, --template   Message template\n```\n\nUse `DoIt.Command` and provide a required `description`, the command name is the module name, you can override that name using the `name` option.\n\n```elixir\ndefmodule Hello do\n  use DoIt.Command,\n    name: \"olleh\",\n    description: \"Useless hello command\"\n\n  ...\n\nend\n```\n\nYou can declare subcommands in a command to group them logically using the `subcommand` macro.\n\n```elixir\ndefmodule HelloWorld.Template do\n  use DoIt.Command,\n    description: \"Manage HelloWorld Template\"\n\n  subcommand(HelloWorld.Template.Set)\n  subcommand(HelloWorld.Template.Unset)\n  subcommand(HelloWorld.Template.Show)\nend\n```","ref":"readme.html#command","title":"Command - README","type":"extras"},{"doc":"There are two ways to generate the binaries.\n\n- [escript](https://hexdocs.pm/mix/Mix.Tasks.Escript.Build.html)\n- [burrito-elixir](https://github.com/burrito-elixir/burrito)\n\n#","ref":"readme.html#package","title":"Package - README","type":"extras"},{"doc":"To generate an application using the escript, you have to add a `:escript` key with the `:main_module` option to your project properties in your `mix.exs` file.\n\nThe `:main_module` is the module that you defined as `DoIt.MainCommand`.\n\n```elixir\n...\n  def project do\n    [\n      app: :hello_world,\n      version: \"0.1.0\",\n      elixir: \"~> 1.14\",\n      start_permanent: Mix.env() == :prod,\n      deps: deps(),\n      escript: [main_module: Cli]\n    ]\n  end\n...\n```\n\nBuild the binary running the mix task bellow.\n\n```shell\n$ mix escript.build\n==> do_it\nCompiling 4 files (.ex)\nGenerated do_it app\n==> hello_world\nCompiling 1 file (.ex)\nGenerated escript hello_world with MIX_ENV=dev\n```\n\nA binary with the application name will be generated in the project root.\n\n```shell\n$ ./hello_world help                                                                                                                                                     ─╯\n\nUsage: hello_world COMMAND\n\nMy useless CLI\n\nCommands:\n  say     Useless hello command\n```\n\n#","ref":"readme.html#escript","title":"escript - README","type":"extras"},{"doc":"To configure the application to use the `burrito-elixir` you have to add the `burrito-elixir` dependency in your project, add the `:mod` property in the `application` function, and the `:releases` key with the releases configuration to your project properties in you `mix.exs` file.\n\nThe `:mod` property value is the module that you defined as `DoIt.MainCommand`.\n\n```elixir\ndefmodule CoinGeckoCli.MixProject do\n  use Mix.Project\n\n  def project do\n    [\n      app: :coin_gecko_cli,\n      version: \"0.1.0\",\n      elixir: \"~> 1.14\",\n      start_permanent: Mix.env() == :prod,\n      deps: deps(),\n      releases: releases()\n    ]\n  end\n\n  # Run \"mix help compile.app\" to learn about applications.\n  def application do\n    [\n      extra_applications: [:logger],\n      mod: {CoinGeckoCli, []}\n    ]\n  end\n\n  # Run \"mix help deps\" to learn about dependencies.\n  defp deps do\n    [\n      {:tesla, \"~> 1.7\"},\n      {:jason, \"~> 1.4\"},\n      {:do_it, \"~> 0.4\"},\n      {:burrito, \"~> 1.3\"},\n      {:tableize, \"~> 0.1.0\"}\n    ]\n  end\n\n  def releases do\n    [\n      coin_gecko_cli: [\n        steps: [:assemble, &Burrito.wrap/1],\n        burrito: [\n          targets: [\n            macos: [os: :darwin, cpu: :x86_64],\n            linux: [os: :linux, cpu: :x86_64],\n            windows: [os: :windows, cpu: :x86_64]\n          ],\n        ]\n      ]\n    ]\n  end\nend\n```\n\nGenerate the binaries using the mix task bellow, a binary of each target will be generated in the `burrito_out` folder of your root application.\n\n```shell\n$ MIX_ENV=prod mix release\n...\n...\n...\n$ cd burrito_out\n$ ls -c1                                                                                                                                                                 ─╯\ncoin_gecko_cli_linux\ncoin_gecko_cli_macos\ncoin_gecko_cli_windows\n\n$ ./coin_gecko_cli_linux help                                                                                                                                            ─╯\n\nUsage: coin_gecko_cli COMMAND\n\nCoinGecko CLI\n\nCommands:\n  list     List assets\n```","ref":"readme.html#burrito-elixir","title":"burrito-elixir - README","type":"extras"},{"doc":"**_Do It_** provides comprehensive shell auto-completion support for bash, fish, and zsh shells. Auto-completion helps users discover available commands, subcommands, and options without needing to remember the exact syntax.\n\n#","ref":"readme.html#auto-completion","title":"Auto-completion - README","type":"extras"},{"doc":"- **Command completion**: Complete command and subcommand names\n- **Option completion**: Complete option flags (`--help`, `-v`, etc.)\n- **Value completion**: Complete option values when allowed values are defined\n- **Context-aware**: Completions are context-sensitive based on the current command path\n- **Multi-shell support**: Generate completion scripts for bash, fish, and zsh\n\n#","ref":"readme.html#features","title":"Features - README","type":"extras"},{"doc":"Every Do It CLI automatically includes completion commands:\n\n```shell\n# Generate completion script for bash\nyour_cli completion bash\n\n# Generate completion script for fish\nyour_cli completion fish\n\n# Generate completion script for zsh\nyour_cli completion zsh\n\n# Show installation instructions\nyour_cli completion install bash\n\n# Internal completion command (used by shell scripts)\nyour_cli completion complete  \n\n# Debug completion information\nyour_cli completion debug\n```\n\n#","ref":"readme.html#built-in-completion-commands","title":"Built-in Completion Commands - README","type":"extras"},{"doc":"##","ref":"readme.html#installation","title":"Installation - README","type":"extras"},{"doc":"Add to your `~/.bashrc`:\n```bash\neval \"$(your_cli completion bash)\"\n```\n\nOr install system-wide:\n```bash\nyour_cli completion bash | sudo tee /etc/bash_completion.d/your_cli\n```\n\n##","ref":"readme.html#bash","title":"Bash - README","type":"extras"},{"doc":"Install completion script:\n```bash\nyour_cli completion fish > ~/.config/fish/completions/your_cli.fish\n```\n\n##","ref":"readme.html#fish","title":"Fish - README","type":"extras"},{"doc":"Add to your `~/.zshrc`:\n```bash\neval \"$(your_cli completion zsh)\"\n```\n\nMake sure you have completion system initialized:\n```bash\nautoload -U compinit\ncompinit\n```\n\n#","ref":"readme.html#zsh","title":"Zsh - README","type":"extras"},{"doc":"You can also generate completion scripts during development:\n\n```bash\n# Generate bash completion to stdout\nmix do_it.gen.completion --shell bash\n\n# Generate fish completion and save to file\nmix do_it.gen.completion --shell fish --output ~/.config/fish/completions/myapp.fish\n\n# Show installation instructions\nmix do_it.gen.completion --shell zsh --install\n\n# Specify main module explicitly\nmix do_it.gen.completion --shell bash --main-module MyApp.CLI\n```\n\n#","ref":"readme.html#using-mix-task","title":"Using Mix Task - README","type":"extras"},{"doc":"You can enhance option completion by specifying allowed values:\n\n```elixir\ndefmodule MyApp.Deploy do\n  use DoIt.Command,\n    description: \"Deploy application\"\n\n  option(:environment, :string, \"Target environment\",\n    allowed_values: [\"dev\", \"staging\", \"prod\"])\n\n  option(:format, :string, \"Output format\",\n    allowed_values: [\"json\", \"yaml\", \"table\"])\n\n  def run(_args, _opts, _context), do: :ok\nend\n```\n\nWith this setup, typing `myapp deploy --environment  ` will complete with `dev`, `staging`, or `prod`.","ref":"readme.html#enhanced-option-support","title":"Enhanced Option Support - README","type":"extras"},{"doc":"Do It is released under the Apache License 2.0 - see the [LICENSE](LICENSE) file.","ref":"readme.html#license","title":"License - README","type":"extras"},{"doc":"Copyright 2021 Rodrigo Zampieri Castilho  \n\nLicensed under the Apache License, Version 2.0 (the \"License\");\nyou may not use this file except in compliance with the License.\nYou may obtain a copy of the License at\n\n    http://www.apache.org/licenses/LICENSE-2.0\n\nUnless required by applicable law or agreed to in writing, software\ndistributed under the License is distributed on an \"AS IS\" BASIS,\nWITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\nSee the License for the specific language governing permissions and\nlimitations under the License.","ref":"license.html","title":"LICENSE","type":"extras"}]}